/* Prova d'esame 05/12/2006 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>
#include <fcntl.h>
#include <dirent.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define DIM 100
#define N 10
#define K 5
#define M 5

struct sockaddr_in local;
struct sockaddr_in remote;


main(int argc,char** argv)
{
  int letti,i, livello, remPort,s,n,res,len = sizeof(struct sockaddr_in);
  char c, remHost[DIM];
  struct hostent* hp;
  /* buffer deve contenere utenti e risorse di un livello piu' eventuali
   * separatori: due '\t' fra i nomi degli utenti e il terminatore finale
   *
   */
  char scelta,buffer[((K+M)*DIM)+((K+M)*2)+1];


  if(argc != 3)
  {
    printf("\nErrore di sintassi, invocazione: %s host porta", argv[0]);
    exit(0);
  }
  remPort = htons(atoi(argv[2]));
  strcpy(remHost,argv[1]);
  memset((char*)&local,0,len);
  memset((char*)&remote,0,len);
  remote.sin_family = AF_INET;
  remote.sin_port = remPort;
  hp = gethostbyname(remHost);
  if(hp == NULL)
  {
    perror("\nErrore nome host locale");
    exit(0);
  }
  remote.sin_addr.s_addr = ((struct in_addr*)(hp->h_addr))->s_addr;
  s = socket(AF_INET,SOCK_STREAM,0);
  if(s < 0)
  {
    perror("\nErrore creazione socket");
    exit(1);
  }
  if(connect(s,(struct sockaddr*)&remote,len) < 0)
  {
    perror("\nImpossibile stabilire una connessione");
    exit(2);
  }
  printf("\nConnessione avvenuta");
  printf("\nDigita v per visualizzare un livello, e per eliminare una risorsa, EOF per terminare\n");
  while((scelta=getchar())!=EOF)
  {
  	res=0;
    // consumo il resto della linea scritto dall'utente,
    // ed in particolare l'andare a capo
    gets(buffer);
    if( scelta!='v' && scelta!='e' ) continue;

    if(write(s, &scelta, 1) < 0)
    {
      perror("\nImpossibile inviare scelta");
      exit(1);
    }
    if(scelta == 'v')
    {
      n=-1;
      while( (n<0) || (n>=N) ){
      	printf("\nNumero livello da visualizzare (da 0 a %d): ", (N-1));
  	    while (scanf("%d", &n) != 1)
	    {
	      /* Problema nellimplementazione della
	       * scanf. Se linput contiene PRIMA
    	   * dellintero altri caratteri la testina
	       * di lettura si blocca sul primo carattere
	       * (non intero) letto. Ad esempio:
	       * |ab1292\n|
	       *  ^     La testina si blocca qui
	       *  |
	       * Bisogna quindi consumare tutto il buffer
	       * in modo da sbloccare la testina.
	       */
	      do
	      {c=getchar(); printf("%c ", c);}
	      while (c!= '\n');
	      printf("\nNumero livello (da 0 a %d): ", N);
        }
        // Consumo il '\n'
        gets(buffer);
      }


      n=htonl(n);
      if( write(s,&n,sizeof(int)) < 0 )
      {
        perror("\nProblemi in scrittura, chiudo!");
        exit(1);
      }

      /*
       * Caso piu' ampio e generale possibile.
       * Prima lettura lunghezza dell'invio del pari,
       * poi lettura dello stream fino alla lunghezza.
       *
       * NOTA: spesso le cose sono semplificate, si evita
       * cioe' l'invio della lunghezza ipotizzando che per
       * invii brevi non ci siano problemi.
       */
      if( read(s,&n,sizeof(int))< 0 )
      {
        perror("\nProblemi in lettura, chiudo!");
        exit(1);
      }

      // Converto la lunghezza della stringa letta
      n=ntohl(n);
      printf("Devo leggere %d caratteri\n", n);

      letti=0;
      while( letti<n ){
      	/*
      	 * Aggiungo i caratteri letti alla fine dell'array
      	 * di caratteri e leggo i caratteri rimanenti.
      	 * NOTA: buffer e' un puntatore a carattere;
      	 * buffer+letti, e' il puntatore al prossimo
      	 * elemento dell'array di caratteri da riempire
      	 *
      	 * Se tutto va bene effettuo una sola lettura di
      	 * n caratteri
      	 */
      	i=read(s,buffer+letti,n-letti);
      	printf("Letti %d caratteri\n", i);
      	if(i<0)
        {
          perror("\nProblemi in lettura, chiudo!");
          exit(1);
        }
        letti=letti+i;
      }
      // Aggiungo il terminatore finale
      buffer[letti]='\0';


      // Stampa a video
      printf("Ecco lo stato della linea: %s\n", buffer);
    }

    if(scelta == 'e')
    {
      printf("\nNome della risorsa da eliminare: ");
      gets(buffer);

      n=strlen(buffer);
      n=htonl(n);

      /*
       * Caso piu' ampio e generale possibile.
       * Prima invio lunghezza dell'array di caratteri che devo
       * scrivere al pari, poi scrittura dell'array
       *
       * NOTA: spesso le cose sono semplificate, si evita
       * cioe' l'invio della lunghezza ipotizzando che per
       * invii brevi non ci siano problemi.
       */
      if( write(s,&n,sizeof(int)) < 0 )
      {
        perror("\nProblemi in scrittura, chiudo!");
        exit(1);
      }
      /*
       * Scrittura nome su socket con singolo invio.
       * Alternativa possibile, invii multipli.
       *
       * Per l'invio di quantita' di dati maggiori, ad
       * esempio file, si usino sempre invii multipli!
       *
       */
      i=write(s,buffer,strlen(buffer));
      if( i < 0 || i!=strlen(buffer))
      {
        perror("\nProblemi in scrittura, chiudo!");
        exit(1);
      }

	  // Lettura risultato fino alla terminazione degli invii segnalata con -1
	  printf("Elenco livelli liberati:\n");
      while((i=read(s,&livello,sizeof(int)))>0)
      {
      	livello=ntohl(livello);
      	if(livello == -1) break;
      	else printf("Livello %d\n", livello);
      }
      if(i<0){
        perror("\nProblemi in lettura, chiudo!");
        exit(1);
      }
    }
    printf("\nDigita v per visualizzare un livello, e per eliminare una risorsa, EOF per terminare\n");

  }  //while
  close(s);
  printf("\nConnessione chiusa");
}
