/* Prova d'esame 05/12/2006 */

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.rmi.Naming;
import java.rmi.RemoteException;

public class Client {

  private final static int N = 10;

  public static void main(String[] args) {
    final int REGISTRYPORT = 1099;

    String registryHost = null;
    String serviceName = "ServerRMI";
    BufferedReader stdIn = new BufferedReader(new InputStreamReader(System.in));

    // Controllo dei parametri della riga di comando
    if (args.length != 1) {
      System.out.println("Sintassi: Client NomeHost");
      System.exit(1);
    }
    registryHost = args[0];

    // Connessione al servizio RMI remoto
    try {
      String completeName = "//" + registryHost + ":" + REGISTRYPORT + "/"
          + serviceName;
      RemOp serverRMI = (RemOp) Naming.lookup(completeName);
      System.out
          .println("ClientRMI: Servizio \"" + serviceName + "\" connesso");

      System.out.println("\nRichieste di servizio fino a fine file");

      String service;
      String nomeUtente, nomeRisorsa;
      boolean ok = false;
      int livello = -1;

      System.out.print("Servizio (AR=aggiungi risorsa,EU=elimina utente): ");

      while ((service = stdIn.readLine()) != null) {
        ok = false;
        if (service.equals("AR")) {
          System.out.print("Inserisci l'identificativo del livello da 0 a "
              + (N - 1) + ": ");

          while (!ok) {
            try {
              livello = Integer.parseInt(stdIn.readLine());
              if (livello < 0 || livello >= N)
                System.out.print("Identificativo del livello da 0 a " + (N - 1)
                    + ": ");
              else
                ok = true;
            } catch (Exception e) {
              System.out.print("Inserisci l'identificativo del livello da 0 a "
                  + (N - 1) + ": ");
            }
          }
          System.out.print("Inserisci nome utente: ");
          nomeUtente = stdIn.readLine();
          System.out.print("Inserisci nome risorsa: ");
          nomeRisorsa = stdIn.readLine();

          try {
            if (serverRMI.aggiungi_risorsa(livello, nomeUtente, nomeRisorsa) == 0) {
              System.out.println("Aggiunta la risorsa");
            } else {
              System.out.println("Problemi, risorsa non aggiunta!");
            }
          } catch (RemoteException re) {
            System.out.println("Errore remoto: " + re);
          }

        } // AS

        else if (service.equals("EU")) {
          System.out.print("Inserisci il nome dell'utente da eliminare: ");
          nomeUtente = stdIn.readLine();

          try {

            if (serverRMI.elimina_utente(nomeUtente) == 0) {
              System.out.println("Utente eliminato");
            } else {
              System.out.println("Problemi durante l'eliminazione utente");
            }
          } catch (RemoteException re) {
            System.out.println("Errore remoto: " + re);
          }
        } // EU

        else
          System.out.println("Servizio non disponibile");

        System.out.print("Servizio (AR=aggiungi risorsa,EU=elimina utente): ");

      } // !EOF

    } catch (Exception e) {
      System.err.println("ClientRMI: " + e.getMessage());
      e.printStackTrace();
      System.exit(1);
    }
  }
}